#include <miller-rabin.h>
#include <module.h>
#include <random.h>


giantint PowMod(giantint a, giantint b, giantint n)
{
	giantint c = 0;
        giantint d = 1;
        int k = sizeof(b) * 8 - 1;

        for (int i = k; i >= 0; i--)
        {
        	c <<= 1;
                d = Module(d * d, n);
                if ((b >> k) & 0x1)
                {
                	c++;
                        d = Module(a * d, n);
                }
        }
        return d;
}


/*
 n = (2 ^ t) * u
 t = numero di zero a dx
 u = quello che resta tolti gli zeri
*/
void BaseShift(giantint n, giantint * u, giantint * t)
{
  (*t) = 0;
  (*u) = n - 1;

  while (!((*u) & 0x1))
  {
    (*t) ++;
    (*u) >>= 1;
  }
}

bool Wit(giantint a, giantint n)
{
        giantint u, t;
        BaseShift(n, &u, &t);

        giantint x = PowMod(a, u, n);

        for (giantint i = 0; i < t; i++)
        {
        	giantint xold = x;
                x = Module(xold * xold, n);
                if ((x == 1) && (xold != 1) && (xold != (n - 1))) return true;
        }
        return (x != 1);
}


bool PrimeTest(giantint n, int reliability = 20)
{
  for (int i = 0; i < reliability; i++)
  {
    if (Wit(RandomRange(1, n - 1), n)) return false;
  }
  return true;
}
